struct bdfglyph;
struct bdffont;

typedef void bdf_status_fn(struct bdfglyph*,int,int);

struct bdffont *new_bdffont();
struct bdffont *load_font_alloc(const char * filename, bdf_status_fn*callback);
void save_font_struct(const char * filename, struct bdffont *font, bdf_status_fn*callback);
void free_bdffont(struct bdffont *font);

struct bdfglyph *get_glyph(struct bdffont *font, unsigned i);
struct bdfglyph **get_glyph_array(struct bdffont *font);
void set_glyph(struct bdffont *font, unsigned i, struct bdfglyph *g);

const char *get_font_name(struct bdffont *font);
const int *get_font_bbx(struct bdffont *font);
unsigned font_nchars(struct bdffont *font);
unsigned font_glyph_slots(struct bdffont *font);
void copy_font_info(struct bdffont *to, struct bdffont *from);

struct bdfglyph *make_blank_char(unsigned gi);
struct bdfglyph *copy_char(unsigned gi, struct bdfglyph *gc);
void calc_bbx(struct bdfglyph *g);
void outputasbitmap(struct bdfglyph *g,int y, int x);
void shift_glyph_bitmap(struct bdfglyph *g, char direction);
void edit_glyph_pixel(struct bdfglyph *g, int y, int x, int op);
int get_glyph_pixel(struct bdfglyph *g, int y, int x);
const char *get_glyph_name(struct bdfglyph *g);
unsigned get_glyph_encoding(struct bdfglyph *g);
int glyph_bitwise_cmp(struct bdfglyph *a, struct bdfglyph *b);
