#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <unistd.h>
#include <sys/mman.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include "bdf.h"
#include "u8.h"
#include "unidat.h"

int char_cmp_bitwise(struct bdfglyph** a,struct bdfglyph ** b) {
	int c = glyph_bitwise_cmp(*a, *b);
	if(c != 0 || !*a) return c;
	unsigned au = get_glyph_encoding(*a);
	unsigned bu = get_glyph_encoding(*b);
	return 0;
}

int main(int argc, char **argv) {
	const char *filename = argv[1];
	load_unidat();
	struct bdffont *font = load_font_alloc(filename, NULL);
	qsort(get_glyph_array(font),font_glyph_slots(font),sizeof(struct bdfglyph*),(__compar_fn_t)char_cmp_bitwise);
	int i;
	int A = 0;
	fprintf(stderr,"read font\n");
	for(i=0; i<font_glyph_slots(font)-1; i++) {
		if(get_glyph(font,i) == NULL || get_glyph(font,i+1) == NULL)continue;
		if(!char_cmp_bitwise(get_glyph_array(font)+i,get_glyph_array(font)+i+1)) {
			if(A==0){
				unsigned enc = get_glyph_encoding(get_glyph(font,i));
				const char *name = get_unidat_entry(enc);
				if (!name)name = "noname;";
				int namelen = strchr(name,';')-name;
				printf("X %x %.*s\n",enc,namelen,name);
			}
			unsigned enc = get_glyph_encoding(get_glyph(font,i+1));
			const char *name = get_unidat_entry(enc);
			if (!name)name = "noname;";
			int namelen = strchr(name,';')-name;
			printf("X %x %.*s\n",enc,namelen,name);
			A = 1;
		}else if (A!=0) {
			printf("\n");
			A = 0;
		}
	}
	unload_unidat();
	free_bdffont(font);
	return 0;
}
