#include <string.h>
#include <stdarg.h>
#include <byteswap.h>
#include <stdio.h>
#include <stdlib.h>
#include <stdint.h>
#include "etc.h"

unsigned leftshft(unsigned x,int i){
	if(i>0)return x << i;
	if(i<0)return x >> -i;
	return x;
}

int strprfx(const char *s, const char *p) {
	return strncmp(s,p,strlen(p));
}

void chomp(char *s){
	int i = strlen(s);
	if(s[i-1] == '\n')s[i-1] = 0;
}

int printf_abort(const char *format, ...) {
	va_list list;
	va_start(list, format);
	vprintf(format, list);
	va_end(list);
	abort();
}

uint32_t read32(FILE *f){
	uint32_t c;
	if(fread(&c,4,1,f)!=1)c=0;
	return bswap_32(c);
}

void write32(FILE *f,uint32_t c){
        c=bswap_32(c);
	fwrite(&c,4,1,f);
}

void write64(FILE *f,uint64_t c){
	c=bswap_64(c);
	fwrite(&c,8,1,f);
}

void writestr(FILE *f,const char*s){
	fwrite(s,1,strlen(s),f);
}

void writemem(FILE *f,const char*s,int z){
	fwrite(s,1,z,f);
}

void writeu16hack(FILE *f,const char*s,int len){
	char ss[len*2];
	int i;
	for(i=0;i<len;i++){
		ss[i*2]=0;
		ss[i*2+1]=s[i];
	}
	fwrite(ss,1,len*2,f);
}

uint16_t read16(FILE *f){
	uint16_t c;
	if(fread(&c,2,1,f)!=1)c=0;
	return bswap_16(c);
}

void write16(FILE *f, uint16_t c){
	c=bswap_16(c);
	fwrite(&c,2,1,f);
}

void write8(FILE *f, uint8_t c){
	fwrite(&c,1,1,f);
}

void goloc(FILE *f, long loc){
	fseek(f,loc,SEEK_SET);
}

void gorel(FILE *f, long x){
	fseek(f,x,SEEK_CUR);
}

void ffastfw(FILE *f){
	fseek(f,0,SEEK_END);
}

void writefile(FILE *f,FILE*g){
	rewind(g);
	char c[1024];
	int n=0;
	while((n=fread(c,1,1024,g))==1024)fwrite(c,1,n,f);
	if(n!=0)fwrite(c,1,n,f);
}

void checkext(const char *name, const char *ext){
	const char *i=name;
	const char *j=ext;
	while(*i)i++;
	while(*j)j++;
	while(j >= ext){
		if(*i != *j){
			fprintf(stderr,"Extension mismatch: %s want %s\r\n",name,ext);
			abort();
		}
		i--;j--;
	}
}


void bublesort(char *array, unsigned n_elems, unsigned elem_z, int (*comp)(const void *a,const void*b)){
 int i,j;
 char buf[elem_z];
 for(j=0;j<n_elems;j++){
  for(i=0;i<n_elems-1;i++){
   int c=comp(array+i*elem_z,array+(i+1)*elem_z);
   if(c>0){
     memcpy(buf,array+(i+1)*elem_z,elem_z);
     memcpy(array+(i+1)*elem_z,array+i*elem_z, elem_z);
     memcpy(array+i*elem_z,buf,elem_z);
   }
  }
 }
}
