#include "stdio.h"
#include "stdlib.h"
#include "stdint.h"
#include "string.h"
#include "u8.h"
#include "unidat.h"

uint32_t read32(FILE *f){
	uint32_t c;
	if(fread(&c,4,1,f)!=1){printf("failed\n");abort();}
	c = c >> 16 | c << 16;
	c = (c >> 8 & 0xFF00FF) | (c << 8 & 0xFF00FF00);
	return c;
}

uint16_t read16(FILE *f){
	uint16_t c;
	if(fread(&c,2,1,f)!=1){printf("failed\n");abort();}
	c = c >> 8 | c << 8;
	return c;
}

int main(int argc, char **argv){
	int a = 1;
	int onlyranges = 0;
	if(a >= argc)return (printf ("need a filename\n"),1);
	if(!strcmp(argv[a],"-r")){
		onlyranges=1;
		a++;
	}
	if(a >= argc)return (printf("need a filename\n"),1);
	load_eawdat();
	FILE *f = fopen(argv[a],"r+");
	while(read32(f)!=0x636d6170);
	read32(f);//discard checksum, fuck that
	uint32_t cmap_loc = read32(f);
	//printf("cmap is at %x\n",cmap_loc);
	fseek(f,cmap_loc,SEEK_SET);
	read32(f);//discard table header
	while(read32(f)!=0x3000A)//skip to UCS-4 table
		read32(f);//skip...
	uint32_t ucs4_loc = cmap_loc + read32(f);
	//printf("ucs4 is at %x\n",ucs4_loc);
	fseek(f,ucs4_loc,SEEK_SET);
	if(read16(f)!=12)return(printf("ucs4 table not format 12\n"),1);
	fseek(f,ucs4_loc + 12,SEEK_SET);
	uint32_t i,n_ranges = read32(f);
	uint32_t n = 0;
	int countkanji = 0;
	int counthangul = 0;
	int total = 0;
	n = 0;
	for(i=0;i<n_ranges;i++){
		uint32_t sta,end;
		sta = read32(f);
		end = read32(f);
		total += end - sta + 1;
		read32(f);//ignore glph id.
		if(!onlyranges)while(sta <= end){
			if(get_eaw(sta)==0)u8putch(0x25CC);
			u8putch(sta);
			if(sta >= 0x4E00 && sta < 0xA000)countkanji++;
			if(sta >= 0xAC00 && sta < 0xD7B0)counthangul++;
			int w = get_eaw(sta);
			if(w == 0)w = 1;
			n += w;
			sta++;
			if( n >= 64 ){putchar('\n');n=0;}
		}else{
			printf("range %d U%x U%x\n",i,sta,end);
		}
	}
	printf("\nthere are %d characters supported\n",total);
	printf("there are %d hangul precomposed characters supported\n",counthangul);
	printf("there are %d non-hangul characters supported\n",total-counthangul);
	printf("there are %d chinese characters supported\n",countkanji);
	return 0;
}
